<?php

/**
 * @class CreateController
 * Controls the browsing of the records
 */

class CreateController extends BaseController
{
	public function getViewId() {

		$id = 'create_' . $_GET['modelClass'] . '_' . $_GET['modelLevel'];
		
		if (isset($_GET['modelPk']))
			$id	.= preg_replace('/"/','',$_GET['modelPk']);
		
		if (isset($_GET['modelRelationName']))
			$id	.= $_GET['modelRelationName'];
		
		return $id;
	}

/**
 * Main render action, renders the form
 */
	public function actionIndex($opt = array())
	{
		$opt = array_merge($_GET, $opt);		

		$this->renderPartial('index',$opt,false,true);

		if (Yii::app()->request->isAjaxRequest)
			Yii::app()->end();
	}

/**
 * Create action
 */
	public function actionCreate($createModelClass=null, $modelRelationName=null, $modelPk=null)
	{
		$opt = array();

		if (@$_POST[$createModelClass]) {

			$model = new $createModelClass();
			$model->setAttributes($_POST[$createModelClass], false);
			
		  //Yii::log('$id::'.@print_r($id, true));
		  //Yii::getLogger()->flush(true);
			
			if ($model->save()) {
				
				if ($modelRelationName && $modelPk) {
					$parentModel = XcruderActiveRecord::getModelFromRequestPk();
					
					$rc = @$_GET['modelRelationClass'];
					$parentModel->addRelatedRecord($modelRelationName, $model, $rc == CActiveRecord::MANY_MANY || $rc == CActiveRecord::HAS_MANY);
					
					$parentModel->updateRelated($modelRelationName);
				}
	
				$opt['success'] = Yii::t('XcruderModule.t', 'create-success');
			} else {
				$opt['error'] = Yii::t('XcruderModule.t', 'create-error');
			}

		}
		
		//$opt['_display'] = $_REQUEST;
		
		//re-rendering the form
		$this->actionIndex($opt);
	}

}
