<?php

/**
 * @class UpdateController
 * Controls the browsing of the records
 */

//Yii::import('xcruder.components.BaseController');

class UpdateController extends BaseController
{
	
	public function getViewId() {

		$id = 'update_' . $_GET['modelClass'] . '_' . $_GET['modelLevel'];
		
		if (isset($_GET['modelPk']))
			$id	.= preg_replace('/"/','',$_GET['modelPk']);
		
		if (isset($_GET['modelRelationName']))
			$id	.= $_GET['modelRelationName'];
		
		return $id;
	}

/**
 * Main render action, renders the form
 */
	public function actionIndex($opt = array())
	{
		$opt = array_merge($_GET, array(
			'updatePk'=>CJSON::decode(@$_GET["updatePk"], true)
		), $opt);
		
		$this->renderPartial('index',$opt,false,true);
		
		if (Yii::app()->request->isAjaxRequest)
			Yii::app()->end();
	}

/**
 * Update action
 */
	public function actionUpdate()
	{

		$updateModelClass = @$_POST["updateModelClass"];
		$updatePk = @CJSON::decode(@$_POST["updatePk"], true);

		$opt = array();

		if ($updatePk && $updateModelClass) {
			
			$model = $updateModelClass::model()->findByPk($updatePk);
			$model->setAttributes($_POST[$updateModelClass], false);

			//Yii::log( 'actionUpdate2a::::' . print_r( $_POST[$updateModelClass] ,true) );
			//Yii::log( 'actionUpdate2b::::' . print_r( $model->attributes ,true) );

			if ($model->save()) {
				$opt['success'] = Yii::t('XcruderModule.t', 'update-success');
			} else {
				$opt['error'] = Yii::t('XcruderModule.t', 'update-error');
			}

		}
		
		//$opt['_display'] = $_REQUEST;
		
		//re-rendering the form
		$this->actionIndex($opt);
	}

}
